From ac03137b2283c45ad0538188728d9691fa7a4883 Mon Sep 17 00:00:00 2001
From: Razvan Stefanescu <razvan.stefanescu@nxp.com>
Date: Mon, 30 Apr 2018 11:27:27 +0300
Subject: [PATCH] staging: dpaa2-evb: Defer probe if no mc portal is found

Signed-off-by: Razvan Stefanescu <razvan.stefanescu@nxp.com>
---
 drivers/staging/fsl-dpaa2/evb/evb.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

--- a/drivers/staging/fsl-dpaa2/evb/evb.c
+++ b/drivers/staging/fsl-dpaa2/evb/evb.c
@@ -1206,10 +1206,14 @@ static int evb_probe(struct fsl_mc_devic
 
 	err = fsl_mc_portal_allocate(evb_dev, FSL_MC_IO_ATOMIC_CONTEXT_PORTAL,
 				     &priv->mc_io);
-	if (unlikely(err)) {
-		dev_err(dev, "fsl_mc_portal_allocate err %d\n", err);
+	if (err) {
+		if (err == -ENXIO)
+			err = -EPROBE_DEFER;
+		else
+			dev_err(dev, "fsl_mc_portal_allocate err %d\n", err);
 		goto err_free_netdev;
 	}
+
 	if (!priv->mc_io) {
 		dev_err(dev, "fsl_mc_portal_allocate returned null handle but no error\n");
 		err = -EFAULT;
